All Classes Namespaces Functions Variables Groups Pages
FixedLengthUtil::FixedLengthFileIterator Class Reference

Structured line iterator for fixed-length line files allowing efficient "pipelined" processing. More...

Inheritance diagram for FixedLengthUtil::FixedLengthFileIterator:
[legend]

## Public Member Functions

| constructor (string path, hash spec, *hash opts)
| Instantiates the FixedLengthFileIterator object. More...
string | getEncoding ()
| Returns the character encoding for the file.
string | getFileName ()
| Returns the file path/name used to open the file.
hash< Qore::StatInfo > | hstat ()
| Returns a StatInfo hash of the underlying file.
list | stat ()
| Returns a stat list of the underlying file.
Public Member Functions inherited from FixedLengthUtil::FixedLengthAbstractIterator
bool | checkTransition (*string from, *string to)
| A verification function to be called for each line. This method can be overridden to achieve a begin-to-end validation of the whole input file. More...
| constructor (AbstractLineIterator li, hash spec, *hash opts)
| Instantiates the FixedLengthAbstractIterator object. More...
*hash | getValue ()
| Returns the current record as a hash. More...
string | identifyType (string input_line)
| Identify a fixed-length line type using identifyTypeImpl(), that may be overridden if necessary. More...
*string | identifyTypeImpl (string input_line)

Identify a fixed-length line type, given the raw line string. This method performs a lookup to a precalculated table based on line lengths (see constructor()). In case different criteria are needed, eg. when two line types in a spec have the same length and no unique resolving rule are specified, this method needs to be overridden, and will throw an exception, because the precalculated mapping will be empty. More...

bool | next ()
| Moves the current line / record position to the next line / record; returns False if there are no more lines to iterate. More...
auto | transform (auto value, hash type)
| parses the input value based on global configuration and the current field definition

## Private Attributes

string | m_file_path
| the path of the file being iterated

## Detailed Description

Structured line iterator for fixed-length line files allowing efficient "pipelined" processing.

Example:
  #!/usr/bin/env qore
  %new-style
  %enable-all-warnings
  %require-types
  %strict-args
  %requires FixedLengthUtil
  hash specs = (
  "type1": (
  "col1": ("length": 5, "type": "int"),
  "col2": ("length": 2, "type": "string"),
  ),
  "type2": (
  "col3": ("length": 1, "type": "string"),
  "col4": ("length": 3, "type": "string"),
  "col5": ("length": 8, "type": "date", "format": "DDMMYYYY",
  #"timezone": "Europe/Prague", # use global if omitted
  ),
  ),
  );
  hash global_options = (
  "encoding" : "UTF-8",
  "eol" : "\n",
  "ignore_empty": True,
  "timezone" : "Europe/Prague", # used if not overridden in a date field specification
  );
  FixedLengthFileIterator i(file, specs, global_options);
  # output all records
  map printf("%y\n", $1), i;

See Also
  - FixedLengthIterator for a stream-based class providing the same functionality as this class in a more generic way

## Member Function Documentation

FixedLengthUtil::FixedLengthFileIterator::constructor | ( | string | path,
|  | hash | spec,
|  | *hash | opts
| ) |  |

Instantiates the FixedLengthFileIterator object.

Parameters

  path | File path to read
  spec | Fixed-length line specification; see Specification Hash for more information
  opts | Global options; see Global Options for more information